
package net.mcreator.mysticalmooshrooms.item;

import net.minecraftforge.registries.ForgeRegistries;

import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ArmorMaterial;
import net.minecraft.world.item.ArmorItem;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.Entity;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.resources.ResourceLocation;

import net.mcreator.mysticalmooshrooms.init.MysticalMooshroomsModTabs;
import net.mcreator.mysticalmooshrooms.init.MysticalMooshroomsModItems;

public abstract class MooshriteItem extends ArmorItem {
	public MooshriteItem(EquipmentSlot slot, Item.Properties properties) {
		super(new ArmorMaterial() {
			@Override
			public int getDurabilityForSlot(EquipmentSlot slot) {
				return new int[]{13, 15, 16, 11}[slot.getIndex()] * 35;
			}

			@Override
			public int getDefenseForSlot(EquipmentSlot slot) {
				return new int[]{4, 7, 8, 4}[slot.getIndex()];
			}

			@Override
			public int getEnchantmentValue() {
				return 24;
			}

			@Override
			public SoundEvent getEquipSound() {
				return ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("block.shroomlight.place"));
			}

			@Override
			public Ingredient getRepairIngredient() {
				return Ingredient.of(new ItemStack(MysticalMooshroomsModItems.MOOSHRITE_INGOT.get()));
			}

			@Override
			public String getName() {
				return "mooshrite";
			}

			@Override
			public float getToughness() {
				return 0.5f;
			}

			@Override
			public float getKnockbackResistance() {
				return 1f;
			}
		}, slot, properties);
	}

	public static class Helmet extends MooshriteItem {
		public Helmet() {
			super(EquipmentSlot.HEAD, new Item.Properties().tab(MysticalMooshroomsModTabs.TAB_MYSTICAL_MOOSHROOMS));
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "mystical_mooshrooms:textures/models/armor/diamond__layer_1.png";
		}
	}

	public static class Chestplate extends MooshriteItem {
		public Chestplate() {
			super(EquipmentSlot.CHEST, new Item.Properties().tab(MysticalMooshroomsModTabs.TAB_MYSTICAL_MOOSHROOMS));
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "mystical_mooshrooms:textures/models/armor/diamond__layer_1.png";
		}
	}

	public static class Leggings extends MooshriteItem {
		public Leggings() {
			super(EquipmentSlot.LEGS, new Item.Properties().tab(MysticalMooshroomsModTabs.TAB_MYSTICAL_MOOSHROOMS));
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "mystical_mooshrooms:textures/models/armor/diamond__layer_2.png";
		}
	}

	public static class Boots extends MooshriteItem {
		public Boots() {
			super(EquipmentSlot.FEET, new Item.Properties().tab(MysticalMooshroomsModTabs.TAB_MYSTICAL_MOOSHROOMS));
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "mystical_mooshrooms:textures/models/armor/diamond__layer_1.png";
		}
	}
}
